function tipoDeRecebimento() {
	const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
	const z = new ZeedhiAPIConstructor(browser, protractor);
	const Helper = require('teknisa-helper');
	const geral = new Helper.geral();
	const protractorHelper = require('protractor-helper');
	const self = this;

	this.abrir = () => {
		z.component.menu.open();
		protractorHelper.waitForElementVisibility(element(by.css('.menu-overlay')));
		self.clickByPath(['Parametrização', 'Financeiro', 'Títulos a Receber', 'Tipo de Recebimento']);
		geral.esperarLoading();
        geral.clickAplicarFiltro();
	};
	// Override funçao Zeedhi, pois não funciona para 'Tipo de Recebimento'
	this.clickByPath = function (fullPath) {
		let prefix = '.zh-main-menu>.menu-group>.menu-group-items>';
		let child;
		for (const index in fullPath) {
			if (fullPath.hasOwnProperty(index)) {
				if (fullPath[index] == 'Títulos a Receber') {
					child = element.all(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index])).get(1);
				} else {
					child = element(by.cssWithExactText(prefix + '.menu-item>.menu-link>.menu-title', fullPath[index]));
				}
				child = child.element(by.xpath('..')).element(by.xpath('..'));
				protractorHelper.click(child);
				prefix = '.sub-menu>';
				browser.sleep(500);
			}
		}
	};

    this.adicionar = (codigoRecebimento, nomeTipoRecebimento, tipoDeRecebimento, ordemParaTroco, tipoTroco,
        descricaoRecebimento, emiteVale, debitoConta, taxaAdministrativa, valorMinimo, diasParaRecebimento,
        codigoCredenciadoraCartao, codigoBandeiraTef, codigoCnpjAdministradoraTicket, codigoBandeiraSefaz,
        solicitaQuantidadeParcela, quantidadeMaximaParcela, valorMinimoParcela, tipoRecebimentoTrocaMercadoria,
        sangriaFechamentoCaixa, manutencaoLancamentoSangria, manutencaoLancamentoEntradaSaida, solicitaVendasCreditoDebito,
        utilizaCartaoVoucher, habilitaVendaGerencial, abreGaveta, controlaRepique) => {
		geral.clickAndFllField('CDTIPORECE', codigoRecebimento);
		geral.clickAndFllField('NMTIPORECE', nomeTipoRecebimento);
		geral.selectNative('IDTIPORECE', tipoDeRecebimento);
		geral.clickAndFllField('NRORDTROCO', ordemParaTroco);
		geral.searchAndClickGridField('NMTIPOTROCO', tipoTroco, 'NMTIPORECE');
        geral.clickAndFllField('DSIMPFISCAL', descricaoRecebimento);
        geral.selectNative('IDEMIVALE', emiteVale);
		geral.selectNative('IDDEBCLIE', debitoConta);
        geral.clickAndFllField('VRTAXAADMI', taxaAdministrativa);
        geral.clickAndFllField('VRMINCARTAO', valorMinimo);
		geral.clickAndFllField('NRDIASADMI', diasParaRecebimento);
        geral.clickAndFllField('CDCREDENCCAR', codigoCredenciadoraCartao);
        geral.clickAndFllField('CDBANCARTCR', codigoBandeiraTef);
		geral.clickAndFllField('CDADMINCART', codigoCnpjAdministradoraTicket);
        geral.selectNative('CDBANCARTSEFAZ', codigoBandeiraSefaz);
        geral.selectNative('IDSOLIQTPARC', solicitaQuantidadeParcela);
		geral.clickAndFllField('QTMAXPARC', quantidadeMaximaParcela);
        geral.clickAndFllField('VRMINPARC', valorMinimoParcela);
        geral.selectNative('IDTPRECTROCAMER', tipoRecebimentoTrocaMercadoria);
		geral.selectNative('IDSANGRIAAUTO', sangriaFechamentoCaixa);
        geral.selectNative('IDPERMANUTSAN', manutencaoLancamentoSangria);
        geral.selectNative('IDPERMANUTVEN', manutencaoLancamentoEntradaSaida);
        geral.selectNative('IDSOLNSUCREDDEB', solicitaVendasCreditoDebito);
        geral.selectNative('IDUTILVOUCHER', utilizaCartaoVoucher);
		geral.selectNative('IDHABVENDAMAN', habilitaVendaGerencial);
        geral.selectNative('IDABGAVTPRECE', abreGaveta);
        geral.selectNative('IDUTCONTRREPIQ', controlaRepique);
	};
	this.editar = (nomeTipoRecebimento, tipoDeRecebimento, ordemParaTroco, tipoTroco, descricaoRecebimento,
		emiteVale, debitoConta, taxaAdministrativa, valorMinimo, diasParaRecebimento, solicitaQuantidadeParcela,
		tipoRecebimentoTrocaMercadoria, sangriaFechamentoCaixa, manutencaoLancamentoSangria, manutencaoLancamentoEntradaSaida,
		habilitaVendaGerencial, abreGaveta, controlaRepique) => {
		browser.sleep(7000);
		geral.fillField('NMTIPORECE', nomeTipoRecebimento);
		geral.selectNative('IDTIPORECE', tipoDeRecebimento);
		geral.fillField('NRORDTROCO', ordemParaTroco);
		geral.clickLimparAutoComplete('NMTIPOTROCO');
		geral.searchAndClickGridField('NMTIPOTROCO', tipoTroco, 'NMTIPORECE');
        geral.fillField('DSIMPFISCAL', descricaoRecebimento);
        geral.selectNative('IDEMIVALE', emiteVale);
		geral.selectNative('IDDEBCLIE', debitoConta);
        geral.fillField('VRTAXAADMI', taxaAdministrativa);
        geral.fillField('VRMINCARTAO', valorMinimo);
		geral.fillField('NRDIASADMI', diasParaRecebimento);
        geral.selectNative('IDSOLIQTPARC', solicitaQuantidadeParcela);
		geral.selectNative('IDTPRECTROCAMER', tipoRecebimentoTrocaMercadoria);
		geral.selectNative('IDSANGRIAAUTO', sangriaFechamentoCaixa);
        geral.selectNative('IDPERMANUTSAN', manutencaoLancamentoSangria);
        geral.selectNative('IDPERMANUTVEN', manutencaoLancamentoEntradaSaida);
        geral.selectNative('IDHABVENDAMAN', habilitaVendaGerencial);
        geral.selectNative('IDABGAVTPRECE', abreGaveta);
        geral.selectNative('IDUTCONTRREPIQ', controlaRepique);
	};
}
module.exports = new tipoDeRecebimento();
