const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geral = new Helper.geral();
const loginPage = new Helper.login();
// const protractorHelper = require('protractor-helper');
const j = require('../../../json/leitorJson.po');
const historicoDeIntegracao = require('../../../page-objects/parametrizacao/financeiro/historicoDeIntegracao.po');
describe('Histórico de Integração', () => {
    beforeAll(() => {
        loginPage.site();
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        historicoDeIntegracao.abrir();
        geral.selectNative('CDOPERACAO', j.getValor('cdoperacao01'));
        z.component.footer.clickRightActionByLabel('Aplicar filtro', true);
    });

    afterAll(() => {
        geral.sair();
    });

    it('Acessar tela de Histórico de Integração', () => {
        expect(z.component.header.getTitle()).toBe('Histórico de Integração');
    }
    );

    it('Editar historico', () => {
        geral.clickGrid('CDOPERACAO', j.getValor('descricaoOperacao'), '13396865262758143361256');
        geral.clickEditar();
        historicoDeIntegracao.editar(j.getValor('historicoIntegracao1'));
        geral.clickSalvar();
        geral.clickVoltar();
        geral.filterIt(j.getValor('historicoIntegracao1'));
        expect(geral.gridHasText('13396865262758143361256', j.getValor('historicoIntegracao1'), 1)).toEqual('TARIFA BANCARIA');
    });

    it('Editar Historico Integracao', () => {
            geral.clickGrid('CDOPERACAO', j.getValor('descricaoOperacao'), '13396865262758143361256');
            geral.clickEditar();
            historicoDeIntegracao.editar(j.getValor('historicoIntegracao2'));
            geral.clickSalvar();
            geral.clickVoltar();
            geral.filterIt(j.getValor('historicoIntegracao2'));
            expect(geral.gridHasText('13396865262758143361256', j.getValor('historicoIntegracao2'), 1)).toEqual('PGTO SALARIO');
    }
    );
});
